"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
}); // func()

function callExpressionHandler(node) {
  var _this = this;

  var funcGetter = this.createCallFunctionGetter(node.callee);
  var argsGetter = node.arguments.map(function (arg) {
    return {
      type: arg.type,
      closure: _this.createClosure(arg)
    };
  });
  return function () {
    var args = [];

    for (var i = 0; i < argsGetter.length; i++) {
      var arg = argsGetter[i];

      if (arg.type === 'SpreadElement') {
        args = args.concat(arg.closure());
      } else {
        args.push(arg.closure());
      }
    }

    return funcGetter().apply(void 0, args);
  };
}

exports.callExpressionHandler = callExpressionHandler;