"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var Symbols_1 = require("../../Symbols"); // a.b a['b'] arr[1]


function memberExpressionHandler(node) {
  var _this = this;

  var objectGetter = this.createClosure(node.object);
  var keyGetter = this.createMemberKeyGetter(node);
  return function () {
    var MArray = _this.globalScope.data['Array'];
    var obj = objectGetter();
    var key = keyGetter();

    if (Symbols_1.isSymbol(key)) {
      // 对于模拟的Symbol属性，实际存储在了一个特殊的key下面
      return obj[Symbols_1.storeKey(key)];
    } // arr[1]


    return obj[key];
  };
}

exports.memberExpressionHandler = memberExpressionHandler;