"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

function getString(val) {
  if (typeof val === 'string') {
    return val;
  } else if (typeof val.toString === 'function') {
    return val.toString();
  } else {
    return Object.prototype.toString.call(val);
  }
} // `hello ${estime}, test`


function templateLiteralHandler(node) {
  var _this = this;

  var vasGetters = node.expressions.map(function (_) {
    return _this.createClosure(_);
  });
  var strs = node.quasis.map(function (_) {
    return {
      value: _.value,
      tail: _.tail
    };
  });
  return function () {
    var str = '';

    for (var i = 0; i < strs.length; i++) {
      // use cooked or raw??
      str += strs[i].value.cooked + (strs[i].tail ? '' : getString(vasGetters[i]()));
    }

    return str;
  };
}

exports.templateLiteralHandler = templateLiteralHandler;