"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var Message_1 = require("../../Message"); // ++a --a


function updateExpressionHandler(node) {
  var _this = this;

  var objectGetter = this.createLeftObjectGetter(node.argument);
  var nameGetter = this.createNameGetter(node.argument);
  return function () {
    var obj = objectGetter();
    var name = nameGetter();

    _this.assertVariable(obj, name, node);

    switch (node.operator) {
      case "++":
        return node.prefix ? ++obj[name] : obj[name]++;

      case "--":
        return node.prefix ? --obj[name] : obj[name]--;

      default:
        throw _this.createInternalThrowError(Message_1.Messages.UpdateOperatorSyntaxError, node.operator, node);
    }
  };
}

exports.updateExpressionHandler = updateExpressionHandler;