"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var Message_1 = require("../../Message"); // [1,2,3]


function arrayExpressionHandler(node) {
  var _this = this; //fix: [,,,1,2]


  var items = node.elements.map(function (element) {
    if (!element) return null;
    return {
      type: element.type,
      // @ts-ignore
      closure: element.type == 'SpreadElement' ? _this.createClosure(element.argument) : _this.createClosure(element)
    };
  });
  return function () {
    var MArray = _this.globalScope.data['Array'];
    var len = items.length;
    var result = new MArray();

    for (var i = 0; i < len; i++) {
      var item = items[i];

      if (!item) {
        result.push(undefined);
      } else {
        if (item.type == 'SpreadElement') {
          var arr = item.closure();

          if (!Array.isArray(arr)) {
            throw _this.createInternalThrowError(Message_1.Messages.NormalError, 'cannot spread, not an array type', node);
          }

          result = result.concat(arr);
        } else {
          result.push(item.closure());
        }
      }
    }

    return result;
  };
}

exports.arrayExpressionHandler = arrayExpressionHandler;