"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var Symbols_1 = require("../../Symbols"); // class Test {...}


function classDeclarationHandler(node) {
  var _this = this;

  var className;
  var classClosure; // class的作用域是块级作用域

  if (node.id) {
    classClosure = this.classExpressionHandler(node);
    var stackTop = this.collectDeclLex[this.collectDeclLex.length - 1];
    stackTop && (stackTop[node.id.name] = {
      init: false,
      kind: 'let'
    });
    className = node.id.name;
  }

  return function () {
    if (className) {
      var scope = _this.getCurrentScope();

      scope.lexDeclared[className].init = true;
      scope.data[className] = classClosure();
    }

    return Symbols_1.EmptyStatementReturn;
  };
}

exports.classDeclarationHandler = classDeclarationHandler;