"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var Scope_1 = require("../../Scope");

var Symbols_1 = require("../../Symbols");

function withStatementHandler(node) {
  var _this = this;

  var objectClosure = this.createClosure(node.object);
  var bodyClosure = this.createClosure(node.body);
  return function () {
    var data = objectClosure();

    var currentScope = _this.getCurrentScope();

    var newScope = new Scope_1.default(data, currentScope, Symbols_1.WithScopeName); // const data = objectClosure();
    // copy all properties
    // for (let k in data) {
    // 	newScope.data[k] = data[k];
    // }

    _this.setCurrentScope(newScope); // save last value


    var result = _this.setValue(bodyClosure());

    _this.setCurrentScope(currentScope);

    return result;
  };
}

exports.withStatementHandler = withStatementHandler;