"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Message_1 = require("../../Message");
// <App.Panel />
function JSXMemberExpressionHandler(node) {
    var dataClosure;
    if (node.object.type == 'JSXIdentifier') {
        dataClosure = this.createClosure({
            type: 'Identifier',
            name: node.object.name
        });
    }
    else if (node.object.type == 'JSXMemberExpression') {
        dataClosure = this.createClosure(node.object);
    }
    else {
        // @ts-ignore
        throw this.createInternalThrowError(Message_1.Messages.NormalError, 'unknown jsxmember type ' + node.object.type, node);
    }
    // jsx中的组件名key不存在computed的情况，例如：<App[name] />
    // 只可能是<App.panel />，name不需要动态计算，所以直接返回字符串的字面量即可
    var keyClosure = function () { return node.property.name; };
    return function () {
        var data = dataClosure();
        var key = keyClosure();
        return data[key];
    };
}
exports.JSXMemberExpressionHandler = JSXMemberExpressionHandler;
