"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Message_1 = require("../../Message");
// a && b
function logicalExpressionHandler(node) {
    var _this = this;
    var leftExpression = this.createClosure(node.left);
    var rightExpression = this.createClosure(node.right);
    return function () {
        switch (node.operator) {
            case "||":
                return leftExpression() || rightExpression();
            case "&&":
                return leftExpression() && rightExpression();
            default:
                throw _this.createInternalThrowError(Message_1.Messages.LogicalOperatorSyntaxError, node.operator, node);
        }
    };
}
exports.logicalExpressionHandler = logicalExpressionHandler;
