"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Message_1 = require("../../Message");
var Symbols_1 = require("../../Symbols");
// typeof a !a()
function unaryExpressionHandler(node) {
    var _this = this;
    switch (node.operator) {
        case "delete":
            var objectGetter_1 = this.createObjectGetter(node.argument);
            var nameGetter_1 = this.createNameGetter(node.argument);
            return function () {
                // not allowed to delete root scope property
                // rootContext has move to prototype chai, so no judgment required
                // if (this.isRootScope(node.argument)) {
                // 	return false;
                // }
                var obj = objectGetter_1();
                var name = nameGetter_1();
                return delete obj[name];
            };
        default:
            var expression_1;
            // for typeof undefined var
            // typeof adf9ad
            if (node.operator === "typeof" && node.argument.type === "Identifier") {
                var objectGetter_2 = this.createObjectGetter(node.argument);
                var nameGetter_2 = this.createNameGetter(node.argument);
                expression_1 = function () { return objectGetter_2()[nameGetter_2()]; };
            }
            else {
                expression_1 = this.createClosure(node.argument);
            }
            return function () {
                var value = expression_1();
                switch (node.operator) {
                    case "-":
                        return -value;
                    case "+":
                        return +value;
                    case "!":
                        return !value;
                    case "~":
                        return ~value;
                    case "void":
                        return void value;
                    case "typeof":
                        if (Symbols_1.isSymbol(value)) {
                            return 'symbol';
                        }
                        return typeof value;
                    default:
                        throw _this.createInternalThrowError(Message_1.Messages.UnaryOperatorSyntaxError, node.operator, node);
                }
            };
    }
}
exports.unaryExpressionHandler = unaryExpressionHandler;
