"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Symbols_1 = require("../../Symbols");
// function test(){}
function functionDeclarationHandler(node) {
    var _this = this;
    var functionClosure;
    var functionName;
    if (node.id) {
        functionClosure = this.functionExpressionHandler(node);
        Object.defineProperty(functionClosure, "isFunctionDeclareClosure", {
            value: true,
            writable: false,
            configurable: false,
            enumerable: false,
        });
        functionName = node.id.name;
        // 函数编译期间，函数名提升为undefined。在声明执行时才确认函数体
        // 参见issue： https://github.com/IAIAE/estime/issues/4
        // @ts-ignore
        this.funcDeclaration(node.id.name, undefined);
        // this.funcDeclaration(node.id.name, functionClosure);
    }
    return function () {
        // 函数声明执行的时候再去绑定作用域，以免产生函数执行时作用域错误绑定的情况
        // https://github.com/IAIAE/estime/issues/4
        if (functionClosure) {
            if (_this._functionVarScope && (_this._functionVarScope.data[functionName] === undefined
                // 重复声明一个同名的函数，会覆盖的
                || typeof _this._functionVarScope.data[functionName] == 'function')) {
                var theFunc = functionClosure(_this.getCurrentScope());
                _this._functionVarScope.data[functionName] = theFunc;
            }
        }
        return Symbols_1.EmptyStatementReturn;
    };
}
exports.functionDeclarationHandler = functionDeclarationHandler;
