"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Symbols_1 = require("../../Symbols");
var TokenClass_1 = require("../../TokenClass");
var Symbols_2 = require("../../Symbols");
// {...} 但是不生成blockScope，组装多个表达式一起执行时，采用这种中间形式的一种数据结构，只有编译器内部使用
function groupStatementHandler(node) {
    var _this = this;
    // const currentScope = this.getCurrentScope();
    // 块级作用域的handler初始化的时候就会遍历下级所有的body，创建closure，创建closure的时候就会完成变量声明提升的操作
    var stmtClosures = node.body.map(function (stmt) {
        // if (stmt.type === "EmptyStatement") return null;
        return _this.createClosure(stmt);
    });
    return function () {
        var result = Symbols_1.EmptyStatementReturn;
        var prevScope;
        var newScope;
        for (var i = 0; i < stmtClosures.length; i++) {
            var stmtClosure = stmtClosures[i];
            // save last value
            var ret = _this.setValue(stmtClosure());
            // if (!stmtClosure) continue;
            // EmptyStatement
            if (ret === Symbols_1.EmptyStatementReturn)
                continue;
            result = ret;
            // BlockStatement: break label;  continue label; for(){ break ... }
            // ReturnStatement: return xx;
            if (result instanceof TokenClass_1.Return ||
                result instanceof TokenClass_1.BreakLabel ||
                result instanceof TokenClass_1.ContinueLabel ||
                result === Symbols_2.Break ||
                result === Symbols_2.Continue) {
                break;
            }
        }
        // save last value
        return result;
    };
}
exports.groupStatementHandler = groupStatementHandler;
