"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Symbols_1 = require("../../Symbols");
var Scope_1 = require("../../Scope");
// if(true){let i = 123;}else{}
function ifStatementHandler(node) {
    var _this = this;
    this.blockDeclareStart();
    var testClosure = this.createClosure(node.test);
    var consequentClosure = this.createClosure(node.consequent);
    var alternateClosure = node.alternate
        ? this.createClosure(node.alternate)
        : /*!important*/ function () { return Symbols_1.EmptyStatementReturn; };
    var lexDeclared = this.blockDeclareEnd();
    return function () {
        var prevScope;
        var newScope;
        if (lexDeclared) {
            newScope = Scope_1.createScope(_this.getCurrentScope(), "BScope(if)", "block");
            newScope.lexDeclared = lexDeclared;
            prevScope = _this.entryBlockScope(newScope);
        }
        var res = testClosure() ? consequentClosure() : alternateClosure();
        // 恢复
        if (lexDeclared) {
            _this.setCurrentScope(prevScope);
        }
        return res;
    };
}
exports.ifStatementHandler = ifStatementHandler;
