"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Symbols_1 = require("../../Symbols");
var TokenClass_1 = require("../../TokenClass");
// label: xxx
function labeledStatementHandler(node) {
    var _this = this;
    var labelName = node.label.name;
    var bodyClosure = this.createClosure(node.body);
    return function () {
        var result;
        var currentScope = _this.getCurrentScope();
        currentScope.labelStack.push(labelName);
        result = bodyClosure(node);
        // stop break label
        if (result instanceof TokenClass_1.BreakLabel && result.value === labelName) {
            result = Symbols_1.EmptyStatementReturn;
        }
        currentScope.labelStack.pop();
        return result;
    };
}
exports.labeledStatementHandler = labeledStatementHandler;
