"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var Message_1 = require("../../Message");
var main_1 = require("../../../interpreter/main");
var util_1 = require("../../../util");
// new Ctrl()
function newExpressionHandler(node) {
    var _this = this;
    var source = this.source;
    var expression = this.createClosure(node.callee);
    var args = node.arguments.map(function (arg) { return _this.createClosure(arg); });
    return function () {
        var construct = expression();
        if (!util_1.isFunction(construct) || construct.__IS_EVAL_FUNC) {
            var callee = node.callee;
            var name_1 = source.slice(callee.start, callee.end);
            throw _this.createInternalThrowError(Message_1.Messages.IsNotConstructor, name_1, node);
        }
        // new Function(...)
        if (construct.__IS_FUNCTION_FUNC) {
            return construct.apply(void 0, __spreadArrays([new main_1.InternalInterpreterReflection(_this)], args.map(function (arg) { return arg(); })));
        }
        return new (construct.bind.apply(construct, __spreadArrays([void 0], args.map(function (arg) { return arg(); }))))();
    };
}
exports.newExpressionHandler = newExpressionHandler;
