"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Symbols_1 = require("../../Symbols");
var TokenClass_1 = require("../../TokenClass");
var Symbols_2 = require("../../Symbols");
var Scope_1 = require("../../Scope");
// {...}
function programHandler(node) {
    var _this = this;
    // const currentScope = this.getCurrentScope();
    // 记录当前块级作用域的所有词法变量的声明
    this.blockDeclareStart();
    // 块级作用域的handler初始化的时候就会遍历下级所有的body，创建closure，创建closure的时候就会完成变量声明提升的操作
    var stmtClosures = node.body.map(function (stmt) {
        // if (stmt.type === "EmptyStatement") return null;
        return _this.createClosure(stmt);
    });
    var functionDecl = node.body.map(function (_, index) { return ({ type: _.type, index: index }); }).filter(function (_) { return _.type == 'FunctionDeclaration'; });
    // 存放了块级作用域变量的列表
    var lexDeclared = this.blockDeclareEnd();
    return function () {
        var result = Symbols_1.EmptyStatementReturn;
        var prevScope;
        var newScope;
        if (lexDeclared) {
            newScope = Scope_1.createScope(_this.getCurrentScope(), "BScope", "block");
            newScope.lexDeclared = lexDeclared;
            prevScope = _this.entryBlockScope(newScope);
        }
        // 如果有函数声明，先执行函数声明：
        functionDecl.forEach(function (_) {
            stmtClosures[_.index]();
            // @ts-ignore
            stmtClosures[_.index] = null;
        });
        stmtClosures = stmtClosures.filter(function (_) { return _; });
        for (var i = 0; i < stmtClosures.length; i++) {
            var stmtClosure = stmtClosures[i];
            // save last value
            var ret = _this.setValue(stmtClosure());
            // if (!stmtClosure) continue;
            // EmptyStatement
            if (ret === Symbols_1.EmptyStatementReturn)
                continue;
            result = ret;
            // BlockStatement: break label;  continue label; for(){ break ... }
            // ReturnStatement: return xx;
            if (result instanceof TokenClass_1.Return ||
                result instanceof TokenClass_1.BreakLabel ||
                result instanceof TokenClass_1.ContinueLabel ||
                result === Symbols_2.Break ||
                result === Symbols_2.Continue) {
                break;
            }
        }
        // 恢复
        if (lexDeclared) {
            _this.setCurrentScope(prevScope);
        }
        // save last value
        return result;
    };
}
exports.programHandler = programHandler;
