import * as handler from './handler';
import { Node } from '../Node';
import { Interpreter } from '../../interpreter/main';
export interface BaseClosure {
    (pNode?: Node): any;
    isFunctionDeclareClosure?: boolean;
}
export declare type CaseItem = {
    testClosure: BaseClosure;
    bodyClosure: BaseClosure;
};
export declare type SwitchCaseClosure = () => CaseItem;
export declare type ReturnStringClosure = () => string;
export declare class ClosureHandler {
    binaryExpressionHandler: typeof handler.binaryExpressionHandler;
    logicalExpressionHandler: typeof handler.logicalExpressionHandler;
    unaryExpressionHandler: typeof handler.unaryExpressionHandler;
    updateExpressionHandler: typeof handler.updateExpressionHandler;
    objectExpressionHandler: typeof handler.objectExpressionHandler;
    arrayExpressionHandler: typeof handler.arrayExpressionHandler;
    callExpressionHandler: typeof handler.callExpressionHandler;
    newExpressionHandler: typeof handler.newExpressionHandler;
    memberExpressionHandler: typeof handler.memberExpressionHandler;
    thisExpressionHandler: typeof handler.thisExpressionHandler;
    sequenceExpressionHandler: typeof handler.sequenceExpressionHandler;
    literalHandler: typeof handler.literalHandler;
    identifierHandler: typeof handler.identifierHandler;
    assignmentExpressionHandler: typeof handler.assignmentExpressionHandler;
    functionDeclarationHandler: typeof handler.functionDeclarationHandler;
    variableDeclarationHandler: typeof handler.variableDeclarationHandler;
    programHandler: typeof handler.programHandler;
    expressionStatementHandler: typeof handler.expressionStatementHandler;
    emptyStatementHandler: typeof handler.emptyStatementHandler;
    returnStatementHandler: typeof handler.returnStatementHandler;
    functionExpressionHandler: typeof handler.functionExpressionHandler;
    ifStatementHandler: typeof handler.ifStatementHandler;
    conditionalExpressionHandler: typeof handler.conditionalExpressionHandler;
    forStatementHandler: typeof handler.forStatementHandler;
    whileStatementHandler: typeof handler.whileStatementHandler;
    doWhileStatementHandler: typeof handler.doWhileStatementHandler;
    forInStatementHandler: typeof handler.forInStatementHandler;
    forOfStatementHandler: typeof handler.forOfStatementHandler;
    withStatementHandler: typeof handler.withStatementHandler;
    throwStatementHandler: typeof handler.throwStatementHandler;
    tryStatementHandler: typeof handler.tryStatementHandler;
    continueStatementHandler: typeof handler.continueStatementHandler;
    breakStatementHandler: typeof handler.breakStatementHandler;
    switchStatementHandler: typeof handler.switchStatementHandler;
    labeledStatementHandler: typeof handler.labeledStatementHandler;
    debuggerStatementHandler: typeof handler.debuggerStatementHandler;
    catchClauseHandler: typeof handler.catchClauseHandler;
    groupStatementHandler: typeof handler.groupStatementHandler;
    arrowFunctionExpressionHandler: typeof handler.arrowFunctionExpressionHandler;
    objectPatternAssignHandler: typeof handler.objectPatternAssignHandler;
    spreadElementHandler: typeof handler.spreadElementHandler;
    templateLiteralHandler: typeof handler.templateLiteralHandler;
    classDeclarationHandler: typeof handler.classDeclarationHandler;
    classExpressionHandler: typeof handler.classExpressionHandler;
    JSXElementHandler: typeof handler.JSXElementHandler;
    JSXMemberExpressionHandler: typeof handler.JSXMemberExpressionHandler;
    JSXExpressionContainerHandler: typeof handler.JSXExpressionContainerHandler;
    JSXTextHandler: typeof handler.JSXTextHandler;
    JSXIdentifierHandler: typeof handler.JSXIdentifierHandler;
    JSXAttributeHandler: typeof handler.JSXAttributeHandler;
    JSXSpreadAttributeHandler: typeof handler.JSXSpreadAttributeHandler;
    superHandler: typeof handler.superHandler;
    protected getClosure(this: Interpreter, node: Node): BaseClosure | null;
}
