export declare class ThrowError extends Error {
}
export declare class ThrowSyntaxError extends SyntaxError {
}
export declare class ThrowReferenceError extends ReferenceError {
}
export declare class ThrowTypeError extends TypeError {
}
export declare class InterruptThrowError extends ThrowError {
}
export declare class InterruptThrowSyntaxError extends ThrowSyntaxError {
}
export declare class InterruptThrowReferenceError extends ThrowReferenceError {
}
interface Messages {
    UnknownError: MessageItem;
    ExecutionTimeOutError: MessageItem;
    NodeTypeSyntaxError: MessageItem;
    BinaryOperatorSyntaxError: MessageItem;
    LogicalOperatorSyntaxError: MessageItem;
    UnaryOperatorSyntaxError: MessageItem;
    UpdateOperatorSyntaxError: MessageItem;
    ObjectStructureSyntaxError: MessageItem;
    AssignmentExpressionSyntaxError: MessageItem;
    VariableTypeSyntaxError: MessageItem;
    ParamTypeSyntaxError: MessageItem;
    AssignmentTypeSyntaxError: MessageItem;
    FunctionUndefinedReferenceError: MessageItem;
    VariableUndefinedReferenceError: MessageItem;
    IsNotConstructor: MessageItem;
    LetVariableUseBeforeInitReferenceError: MessageItem;
    RedeclareBlockScopeVariableError: MessageItem;
    ConstNotInitError: MessageItem;
    ConstChangeError: MessageItem;
    UnknownVariableDeclTypeError: MessageItem;
    SpreadPatternVariableNoInit: MessageItem;
    NormalError: MessageItem;
    VariableNotIterableError: MessageItem;
}
export declare type MessageItem = [number, string, new (message: string) => Error];
export declare const Messages: Messages;
export {};
