declare type ScopeType = 'block' | 'function';
export default class Scope {
    readonly name: string | undefined | Symbol;
    readonly parent: Scope | null;
    readonly data: ScopeData;
    type: ScopeType;
    labelStack: string[];
    lexDeclared: {
        [key: string]: {
            kind: 'const' | 'let';
            init: boolean;
        };
    };
    constructor(data: ScopeData, parent?: Scope | null, name?: string | Symbol, type?: ScopeType);
}
export declare type ScopeData = {
    [prop: string]: any;
    [prop: number]: any;
};
export declare function createScope(parent?: Scope | null, name?: string, type?: ScopeType): Scope;
export {};
