"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function createSymbolFunc() {
    var cache = {};
    var count = {};
    function ESymbol(val) {
        if (this instanceof ESymbol) {
            throw new TypeError('cannot new a Symbol');
        }
        !count[val] && (count[val] = 0);
        count[val] += 1;
        return cache[val] ? new SymbolClass(val, { count: count }) : (cache[val] = new SymbolClass(val, { count: count }));
    }
    ESymbol.iterator = ESymbol('@@iterator');
    ESymbol.match = ESymbol('@@match');
    ESymbol.replace = ESymbol('@@replace');
    ESymbol.search = ESymbol('@@search');
    ESymbol.split = ESymbol('@@split');
    ESymbol.for = function (val) {
        return cache[val] || ESymbol(val);
    };
    ESymbol.keyFor = function (t) {
        if (t instanceof SymbolClass) {
            return t.val;
        }
        else {
            throw new TypeError('keyFor not a symbol');
        }
    };
    return ESymbol;
}
exports.createSymbolFunc = createSymbolFunc;
function isSymbol(t) {
    return typeof t == 'symbol' || t instanceof SymbolClass;
}
exports.isSymbol = isSymbol;
exports.memberKeyPrefix = '__smbl_';
function storeKey(t) {
    return "" + exports.memberKeyPrefix + t.offset + "_" + t.val;
}
exports.storeKey = storeKey;
var SymbolClass = /** @class */ (function () {
    function SymbolClass(val, env) {
        var count = env.count;
        this.val = val;
        // 附加一个偏移量，用于区别val一样的情形
        this.offset = count[val];
    }
    return SymbolClass;
}());
// console.info好像不太管用
SymbolClass.prototype.toString = SymbolClass.prototype.valueOf = function () {
    return "Symbol(" + this.val + ")";
};
