/**
 * 宏任务，供setTimeout和setInterval调用
 */
export declare class MacroTask {
    private _fn;
    constructor(fn: Function);
    run(): void;
}
export declare class MicroTask {
    private _fn;
    constructor(fn: Function);
    run(): void;
}
export declare class MacroTaskList {
    static maxLen: number;
    private maxLen;
    private list;
    /**
     * 微任务队列，唯一一个。宏任务执行时候可以添加
     */
    private microList;
    /**
     * 当前正在运行的虚拟宏任务
     */
    private macroRunning;
    /**
     * 这个时间片需要运行的虚拟宏任务，macroNeedRun和macroRunning这两个字段是同时设置和置空的
     */
    private macroNeedRun;
    /**
     * 如果当前没有宏任务在运行，开发者想入队一个微任务时，就会创造一个虚假的宏任务，将其排在队列的头部，并且指定此指针。如果下次再入队一个微任务时，判断如果存在此指针，就直接入队微任务即可。
     */
    private microFakeTop;
    /**
     * 下一个宏任务延迟执行的timer
     */
    private nextTimer;
    /**
     *
     * @param maxLen 队列中允许存在的最大宏任务数量，防止过度使用导致运行时阻塞
     */
    constructor(maxLen?: number);
    /**
     * 方法入小队
     * @param fn
     */
    microQueue(fn: Function): void;
    /**
     * 方法入大队
     * @param fn
     * @param delay
     */
    queue(fn: Function, delay?: number): void;
    distory(): void;
    private findMacroToRun;
    /**
     * 执行到期的macro队列
     */
    private flush;
    /**
     * 执行到期的macro任务，每执行完一个macro任务，清空一遍micro任务队列
     */
    batchTasks(marcoToRun: {
        task: MacroTask;
        time: number;
    }[]): void;
    private nextRun;
}
